Index: branches/src/ProcessManagement/ProcessManagement/Forms/Master/Material/MaterialItemsMaster/FrmMaterialItemsMaster.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/Master/Material/MaterialItemsMaster/FrmMaterialItemsMaster.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/Master/Material/MaterialItemsMaster/FrmMaterialItemsMaster.cs	(revision 51)
@@ -0,0 +1,1287 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using System.Collections;
+using System.Diagnostics;
+using System.Threading;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.Core;
+using ProcessManagement.Forms.DataEntry;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+//*------------------------ 部署マスタメンテ画面 ----------------------------*
+//  2015/12/04  Ver1.0.0.0      Create Source           
+//
+//
+//
+//*----------------------------------------------------------------------------*
+namespace ProcessManagement.Forms.Master
+{
+    public partial class FrmMaterialItemsMaster : Form
+    {
+        #region 使用定義
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+        /// <summary>
+        /// 表示順番
+        /// </summary>
+        // 表示コントロール定義
+        private enum DispColumn
+        {
+            RowState = 0,
+            DisplayOrder,
+            MaterialItemKey,
+            NameString,
+        }
+        // 経費グリッドカラム
+        private enum ExpGridColumn
+        {
+            ExpensesCode = 0,
+            ExpensesName,
+            Ratio,
+        }
+        private enum GridColumn
+        {
+            No = 0,
+            DepartmentCode,
+            DepartmentString,
+        }
+
+        /// <summary>
+        /// 行動予定表示コンボ文字列
+        /// </summary>
+        private static readonly string[] cmbDspString = new string[] { "表示する", "表示しない" };
+
+        /// <summary>
+        /// Cell幅サイズ
+        /// </summary>
+        private static int[] s_CellSize = new int[] { 0, 460, 100 };
+        #endregion
+
+        #region 変数
+        /// <summary>
+        /// フィールド値変化フラグ
+        /// </summary>
+        private bool m_bChengeAns = false;
+        /// <summary>
+        /// 表示コントロール保持配列
+        /// </summary>
+        private Control[] m_dispControl = new Control[6];
+        /// <summary>
+        /// 終了ボタン押下フラグ
+        /// </summary>
+        private bool m_EndButton = false;
+        /// <summary>
+        /// <summary>
+        /// 資材種類一覧リスト
+        /// </summary>
+        List<String[]> lstDgvWorkListData = new List<String[]>();
+        /// <summary>
+        /// <summary>
+        /// スクロールバー表示オブジェクト
+        /// </summary>
+        VScrollBar vsBar = new VScrollBar();
+
+        /// <summary>
+        /// 構成コード
+        /// </summary>
+        private int m_DepartmentCode = 0;
+
+        /// <summary>
+        /// データ操作
+        /// </summary>
+        private IOMaterialItem  m_IoMt = null;
+        private IOMaterialInfo m_IoMi = null; 
+        private IOMaterialTypes m_IoMtype = null;
+
+        /// <summary>
+        /// 参照フラグ
+        /// </summary>
+        private bool m_EditLock = false;
+        #endregion
+
+        #region プロパティ
+        /// <summary>
+        /// 参照フラグ
+        /// </summary>
+        public bool EditLock
+        {
+            get { return m_EditLock; }
+            set { m_EditLock = value; }
+        }
+        #endregion
+
+        #region コンストラクタ
+        public FrmMaterialItemsMaster()
+        {
+            InitializeComponent();
+        }
+        #endregion
+        #region デストラクタ
+        ~FrmMaterialItemsMaster()
+        {
+            try
+            {
+                GC.Collect();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region ×ボタン押下
+        /// <summary>
+        /// ×ボタン押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialItemsEntry_FormClosing(object sender, FormClosingEventArgs e)
+        {
+            try
+            {
+                if (m_EndButton) return;
+                if (m_bChengeAns)
+                {
+                    if (MessageBox.Show("データに変更があります、登録せずに終了してよろしいですか？。", "終了確認"
+                                    , MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.No)
+                    {
+                        e.Cancel = true;
+                        return;
+                    }
+                }
+
+                // 前プロセスに戻る
+                ClsExcute.BackProcess();
+            }
+            finally
+            {
+                // ロック解除用
+                if (e.Cancel != true && m_IoMt != null)
+                {
+                    m_IoMt.rollback();
+                    m_IoMt.close();
+                    m_IoMt = null;
+                }
+                if (e.Cancel != true && m_IoMi != null)
+                {
+                    m_IoMi.rollback();
+                    m_IoMi.close();
+                    m_IoMi = null;
+                }
+
+            }
+        }
+        #endregion
+
+        #region 終了ボタン
+        /// <summary>
+        /// 終了ボタンクリック
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnEnd_Click(object sender, EventArgs e)
+        {
+            this.Close();
+        }
+        #endregion
+
+        #region フォームロード
+        /// <summary>
+        /// 初期フォームロード
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialItemsEntry_Load(object sender, EventArgs e)
+        {
+            // 行削除押下時にロックを実行する為
+            try
+            {
+                m_IoMt = new IOMaterialItem();
+                m_IoMt.connect();
+                m_IoMt.SetLockWaitime(1);
+                m_IoMt.beginTran();
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                this.Close();
+            }
+
+            // フォームサイズ固定
+            this.MaximizedBounds = new Rectangle(this.Left, this.Top, this.Width, this.Height);
+
+            // データ表示
+            InitDataLoad();
+
+            if (m_EditLock)
+            {
+                btnDataEntry.Enabled = false;
+                btnLineEntry.Enabled = false;
+                btnDataDelete.Enabled = false;
+            }
+
+            // フラグ初期化
+            m_bChengeAns = false;
+
+
+        }
+        #endregion
+
+        #region キーダウン
+        /// <summary>
+        /// Entryキーでの移動処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialItemsEntry_KeyDown(object sender, KeyEventArgs e)
+        {
+            // DataGridviewは処理しない
+            if (ActiveControl.Name.Equals("dgvMaster"))
+            {
+                // セル更新
+                dgvMaster.Rows[dgvMaster.CurrentCell.RowIndex].Cells[(int)DispColumn.RowState].Value = DataRowState.Modified;
+
+                Console.Write("場所 {0} ", "FrmMaterialItemsEntry_KeyDown");
+                Console.WriteLine("     {0} 行目 更新", dgvMaster.CurrentCell.RowIndex);
+
+                //// 最終行時の処理
+                //GridLastLine();
+                return;
+            }
+        }
+        #endregion
+
+        #region フィールド値変更
+        /// <summary>
+        /// フィールド値変更フラグ
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void valueChange(object sender, EventArgs e)
+        {
+            m_bChengeAns = true;
+
+            // セル更新
+            dgvMaster.Rows[dgvMaster.CurrentCell.RowIndex].Cells[(int)DispColumn.RowState].Value = DataRowState.Modified;
+
+            Console.Write("場所 {0} ", "valueChange");
+            Console.WriteLine("     {0} 行目 更新", dgvMaster.CurrentCell.RowIndex);
+
+        }
+        #endregion
+
+        #region 登録ボタン
+        /// <summary>
+        /// 登録ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDataEntry_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                //データチェック
+                if (!DispFeildCheck()) return;
+
+                if (MessageBox.Show("表示中のデータを登録します。", "登録確認"
+                        , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
+
+                // データ登録
+                MasterDataEntry();
+
+
+                // 表示行退避
+                int iIndex = dgvMaster.FirstDisplayedScrollingRowIndex;
+
+                // 再表示
+                DispGridData();
+
+                // 表示行復元
+                dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+
+                // フォーカス初期化
+                dgvMaster.Focus();
+
+                // 変更フラグクリア
+                m_bChengeAns = false;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+            }
+        }
+        #endregion
+
+        #region 削除ボタン
+        /// <summary>
+        /// 削除ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnLineDelete_Click(object sender, EventArgs e)
+        {
+            IOConstructionMaterialInfo miDB = new IOConstructionMaterialInfo();
+            List<MaterialInfo> MiList = new List<MaterialInfo>();
+            try
+            {
+
+                if (CommonMotions.chkCellBlank(dgvMaster.CurrentRow.Cells[(int)DispColumn.NameString].Value)) return;
+
+                // 工事資材情報確認確認
+                int iItemCnt = miDB.SelectMaterialItemCount(int.Parse(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialItemKey].Value.ToString()));
+                if (iItemCnt > 0)
+                {
+                    MessageBox.Show("貸出中の工事が存在するため削除できません。", "削除確認"
+                    , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+
+                if (MessageBox.Show("選択中のデータを削除します。", "削除確認"
+                    , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return;
+
+                // ロック
+                if (!m_IoMt.RowLock(int.Parse(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialItemKey].Value.ToString()), false))
+                {
+                    MessageBox.Show("他のユーザで編集中のため、処理できません。", "削除確認"
+                    , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                // ロック（資材情報）
+                if (m_IoMi == null)
+                {
+                    m_IoMi = new IOMaterialInfo();
+                    m_IoMi.connect();
+                    m_IoMi.beginTran();
+                }
+                if (!m_IoMi.RowLockUpdate(int.Parse(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialItemKey].Value.ToString()),false))
+                {
+                    m_IoMt.rollback();
+                    MessageBox.Show("他のユーザで編集中のため、処理できません。", "削除確認"
+                    , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                //削除実施
+                string strSQL = m_IoMt.CreatePrimarykeyString(CommonMotions.cnvInt(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialItemKey].Value));
+                if (!m_IoMt.DeleteAction(strSQL, false))
+                {
+                    m_IoMt.rollback();
+                    m_IoMi.rollback();
+                    MessageBox.Show("削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                //削除実施(資材情報)
+                m_IoMi.SelectAction(strSQL, ref MiList, false);
+                if (MiList.Count > 0)
+                {
+                    if (!m_IoMi.DeleteAction(strSQL, false))
+                    {
+                        m_IoMt.rollback();
+                        m_IoMi.rollback();
+                        MessageBox.Show("削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+                }
+
+
+                // 表示行退避
+                int iIndex = dgvMaster.FirstDisplayedScrollingRowIndex;
+
+                // 再表示
+                if (!DispGridData()) return;
+
+                // 表示行復元
+                dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+
+                m_bChengeAns = true;
+
+                // セル更新
+                dgvMaster.Rows[dgvMaster.CurrentCell.RowIndex].Cells[(int)DispColumn.RowState].Value = DataRowState.Modified;
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 新規登録ボタン
+        /// <summary>
+        /// 新規登録ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDataLineEntry_Click(object sender, EventArgs e)
+        {
+            
+            try
+            {
+                // モード表示
+                //lblEditMode.Text = CommonDefine.EditModeStringNew;
+
+                // 登録フォームの活性制御
+                controllDgvMaster(sender,e);
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);  
+            }
+        }
+        #endregion
+
+        #region コンボボックスの選択値を基にしたボタン活性制御
+        /// <summary>
+        /// コンボボックスの選択値を基にしたボタン活性制御
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void controllDgvMaster(object sender, EventArgs e)
+        {
+
+            try
+            {
+                // モードが「新規」の場合
+                ////if (CommonMotions.cnvString(CommonDefine.EditModeStringNew).Equals(lblEditMode.Text)) 
+                //{
+                //    //// 「単独」が選択されている場合
+                //    //if (radioButton1.Checked)
+                //    //{
+                        
+                //    //    // 自動的に選択されている行を外す
+                //    //    dgvMaster.CurrentRow.Selected = false;
+                //    //    dgvMaster.Enabled = false;
+                //    //}
+                //    //else
+                //    //{
+                //    //    dgvMaster.Enabled = true;
+
+                //    //}
+                //}
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 行選択
+        /// <summary>
+        /// 行選択時処理
+        /// </summary>
+        private void DataSelectRow()
+        {
+            if (m_bChengeAns)
+            {
+                if (MessageBox.Show("データに変更があります、登録内容を破棄してよろしいですか？。", "終了確認"
+                                , MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.No)
+                {
+                    return;
+                }
+            }
+            if (dgvMaster.Rows.Count < 1) return;
+            if (dgvMaster.CurrentRow.Index < 0) return;
+            // 空白行は処理しない
+            if (CommonMotions.chkCellBlank(dgvMaster.CurrentRow.Cells[(int)GridColumn.DepartmentCode].Value))
+            {
+                return;
+            }
+
+            m_DepartmentCode = CommonMotions.cnvInt(dgvMaster.CurrentRow.Cells[(int)GridColumn.DepartmentCode].Value);
+
+            // データ取得
+            DispGridData();
+
+            // フォーカスセット
+            m_dispControl[(int)GridColumn.No].Focus();
+
+        }
+        #endregion
+
+
+        #region グリッドクリック
+        /// <summary>
+        /// グリッドクリック
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvWorkList_CellClick(object sender, DataGridViewCellEventArgs e)
+        {
+            // 行選択時処理
+            //DataSelectRow();
+        }
+        #endregion
+
+        #region セル入力後処理
+        /// <summary>
+        /// セル入力後処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvExpenses_CellValidated(object sender, DataGridViewCellEventArgs e)
+        {
+            //DataGridViewTextBoxCell wrkTxt = (DataGridViewTextBoxCell)dgvMaster[e.ColumnIndex, e.RowIndex];
+
+            //if (wrkTxt.ReadOnly) return;
+            //wrkTxt.Value = CommonMotions.cnvDouble(wrkTxt.Value).ToString("0.00");
+        }
+        #endregion
+
+        #region 行アップボタン
+        /// <summary>
+        /// アップボタン
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDispUp_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                // 先頭は処理しない
+                if (dgvMaster.CurrentRow.Index == 0) return;
+
+                int irowcnt = dgvMaster.CurrentRow.Index;
+                if (irowcnt == 0) return;
+                if (CommonMotions.chkObjectIsNull(dgvMaster.Rows[irowcnt - 1].Cells[(int)DispColumn.NameString].Value)) return;
+
+                // グリッドアップキー処理
+                DataGridViewAction.GridRowUpAction((DataGridView)dgvMaster, (int)DispColumn.MaterialItemKey, (int)DispColumn.NameString);
+
+                m_bChengeAns = true;
+                // セル更新
+                dgvMaster.Rows[dgvMaster.CurrentCell.RowIndex].Cells[(int)DispColumn.RowState].Value = DataRowState.Modified;
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+        #endregion
+
+        #region 行ダウンボタン
+        /// <summary>
+        /// ダウンボタン
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDispDown_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                // 最終行は処理しない
+                if ((dgvMaster.CurrentRow.Index + 1) == dgvMaster.Rows.Count) return;
+
+                int irowcnt = dgvMaster.CurrentRow.Index;
+                if (CommonMotions.chkObjectIsNull(dgvMaster.Rows[irowcnt + 1].Cells[(int)DispColumn.NameString].Value)) return;
+                if (CommonMotions.cnvString(dgvMaster.Rows[irowcnt + 1].Cells[(int)DispColumn.NameString].Value).Length == 0) return;
+
+                // グリッドダウンキー処理
+                DataGridViewAction.GridRowDownAction((DataGridView)dgvMaster, (int)DispColumn.MaterialItemKey, (int)DispColumn.NameString);
+
+                m_bChengeAns = true;
+                // セル更新
+                dgvMaster.Rows[dgvMaster.CurrentCell.RowIndex].Cells[(int)DispColumn.RowState].Value = DataRowState.Modified;
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+        #endregion
+
+
+        #region 表示オブジェクトの取得
+        /// <summary>
+        /// 表示オブジェクトの取得
+        /// </summary>
+        private void SetDisplayObject()
+        {
+            ////m_dispControl[(int)DispControl.DepartmentCode] = lblRegistrationDate;
+            //m_dispControl[(int)DispControl.DepartmentString] = txtInput01;
+            //m_dispControl[(int)DispControl.RatioGrid] = dgvMaster;
+            ////m_dispControl[(int)DispControl.StaffAssign] = cmbMaterialTypesDsp;
+            //m_dispControl[(int)DispControl.EditMode] = lblEditMode;
+        }
+        #endregion
+
+
+        #region 画面項目のチェック
+        /// <summary>
+        /// 画面項目のチェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            bool bRet = true;
+            bool bAns = true;
+            string sErrmsg = "";
+
+            try
+            {
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+
+                    // 入力無は処理しない
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.MaterialItemKey].Value).Length == 0
+                            && CommonMotions.chkObjectIsNull(r.Cells[(int)DispColumn.NameString].Value)) continue;
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.MaterialItemKey].Value).Length == 0
+                            && CommonMotions.cnvString(r.Cells[(int)DispColumn.NameString].Value).Length == 0) continue;
+
+                    //名称
+                    bAns = true;
+                    if (CommonMotions.chkObjectIsNull(r.Cells[(int)DispColumn.NameString].Value) || ((string)r.Cells[(int)DispColumn.NameString].Value).Length == 0)
+                    {
+                        bAns = false;
+                        sErrmsg = "資材品目の名称が入力されていません。";
+                    }
+                    else if (r.Cells[(int)DispColumn.NameString].Value != null)
+                    {
+                        // レングスチェック
+                        bAns = CommonMotions.chkStringLength(CommonMotions.cnvString(r.Cells[(int)DispColumn.NameString].Value), 40);
+                        if (bAns == false)
+                        {
+                            sErrmsg = "入力エラーがあります、確認してください。";
+                        }
+                    }
+
+                    if (bAns)
+                    {
+                        // 重複行調査
+                        DataGridViewRow[] rows = dgvMaster.Rows.Cast<DataGridViewRow>()
+                                                                    .Where(x => (string)x.Cells[(int)DispColumn.NameString].Value == (string)r.Cells[(int)DispColumn.NameString].Value).ToArray();
+                        if (rows.Count() > 1)
+                        {
+                            bAns = false;
+                            sErrmsg = "同一の資材品目が既に存在します。";
+                        }
+                    }
+
+                    // 背景色変更
+                    CommonMotions.chgBackColor(r.Cells[(int)DispColumn.NameString], bAns);
+                    bRet &= bAns;
+
+
+                }
+
+                if (!bRet)
+                {
+                    MessageBox.Show(sErrmsg, "データ確認"
+                                                , MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                }
+
+                return bRet;
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region マスタ登録
+        /// <summary>
+        /// マスタ登録
+        /// </summary>
+        private void MasterDataEntry()
+        {
+            try
+            {
+                // 番号降り直し
+                int ino = 0;
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+                    // 入力無は処理しない
+                    if (CommonMotions.chkObjectIsNull(r.Cells[(int)DispColumn.NameString].Value)) continue;
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.NameString].Value).Length == 0) continue;
+
+                    // 番号セット
+                    r.Cells[(int)DispColumn.DisplayOrder].Value = (++ino).ToString();
+                }
+
+                m_IoMtype = new IOMaterialTypes();
+                m_IoMtype.connect();
+                if (m_IoMtype.RowLock(int.Parse(cmbTypes.SelectedValue.ToString()), false) == false)
+                {
+                    MessageBox.Show("他のユーザで編集中のため、処理できません。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    m_IoMtype.rollback();
+                    return;
+                }
+
+                string strKindWhere = m_IoMtype.CreatePrimarykeyString(int.Parse(cmbTypes.SelectedValue.ToString())) + " and DELETEFLG=0";
+                List<MaterialKindMaster> mKindList = new List<MaterialKindMaster>();
+                // 資材種類マスタ存在確認
+                if (!m_IoMtype.SelectAction(strKindWhere, ref mKindList, false))
+                {
+                    m_IoMt.rollback();
+                    m_IoMtype.rollback();
+                    MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+                if(mKindList.Count()!=1)
+                {
+                    MessageBox.Show("資材種類が存在しません。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    m_IoMtype.rollback();
+                    return;
+                }
+
+                // データを画面より取得
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+                    // 入力無は処理しない
+                    if (CommonMotions.chkObjectIsNull(r.Cells[(int)DispColumn.NameString].Value)) continue;
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.NameString].Value).Length == 0) continue;
+
+                    // 更新無は処理しない
+                    //if ((DataRowState)r.Cells[(int)DispColumn.RowState].Value == DataRowState.Unchanged) continue;
+
+                    MaterialItemMaster uwork = new MaterialItemMaster();
+
+                    // データセット
+                    if (CommonMotions.chkCellBlank(r.Cells[(int)DispColumn.MaterialItemKey].Value))
+                    {
+                        // 新規時キーセット
+                        // 履歴がない場合は過去の最大値をとる
+                        uwork.MaterialItemCode = m_IoMt.SelectMaxMaterialItemKeyCount(string.Empty, false) + 1;
+                    }
+                    else
+                    {
+                        uwork.MaterialItemCode = CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialItemKey].Value);
+                    }
+                    uwork.MaterialKindCode = int.Parse(cmbTypes.SelectedValue.ToString());
+                    uwork.MaterialItemName = CommonMotions.cnvString(r.Cells[(int)DispColumn.NameString].Value);
+                    uwork.DisplayOrder = CommonMotions.cnvInt(r.Cells[(int)DispColumn.DisplayOrder].Value);
+
+
+                    // SQL作成
+                    string strSQL = m_IoMt.CreatePrimarykeyString(uwork.MaterialItemCode);
+                    List<MaterialItemMaster> mList = new List<MaterialItemMaster>();
+
+                    // 資材品目マスタ取得
+                    if (!m_IoMt.SelectAction(strSQL, ref mList, false))
+                    {
+                        m_IoMt.rollback();
+                        m_IoMtype.rollback();
+                        MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+
+                    if (mList.Count == 0)
+                    {
+                        // データがない場合は追加
+                        mList.Clear();
+                        mList.Add(uwork);
+
+                        // データ登録
+                        if (!m_IoMt.InsertAction(mList, false))
+                        {
+                            m_IoMt.rollback();
+                            m_IoMtype.rollback();
+                            MessageBox.Show("登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return;
+                        }
+                    }
+                    else
+                    {
+                        // 更新ロック
+                        if (!m_IoMt.RowLock(uwork.MaterialItemCode, false))
+                        {
+                            MessageBox.Show("他のユーザで編集中のため、処理できません。", "登録エラー"
+                            , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            m_IoMtype.rollback();
+                            return;
+                        }
+
+                        // データ登録
+                        if (!m_IoMt.UpdateAction(strSQL, uwork, false))
+                        {
+                            m_IoMt.rollback();
+                            m_IoMtype.rollback();
+                            MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return;
+                        }
+                    }
+                }
+
+                // 成功したらcommit
+                m_IoMt.commit();
+                m_IoMi.commit();
+                m_IoMtype.commit();
+
+                if (m_IoMi != null)
+                {
+                    m_IoMi.close();
+                    m_IoMi = null;
+                    m_IoMtype.close();
+                    m_IoMtype = null;
+                }
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        /// <summary>
+        /// 初期表示処理
+        /// </summary>
+        private void InitDataLoad()
+        {
+            try
+            {
+                // グリッドの行を0に戻す
+                dgvMaster.Rows.Clear();
+
+                //素材種類表示
+                LoadMaterialKind();
+
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        #region グリッドデータ表示
+        /// <summary>
+        /// グリッドデータ表示
+        /// </summary>
+        private bool DispGridData()
+        {
+
+            try
+            {
+                ItemListDisplay();
+
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+
+
+        #region グリッドの有効行をカウントする
+        /// <summary>
+        /// グリッドの有効行をカウントする
+        /// </summary>
+        /// <returns></returns>
+        private int GetGridLineEffectivenessCount()
+        {
+            try
+            {
+                int linecount = 0;
+                foreach (DataGridViewRow wrkRow in dgvMaster.Rows)
+                {
+                    if (CommonMotions.chkCellBlank(wrkRow.Cells[(int)GridColumn.DepartmentString].Value)) continue;
+
+                    linecount++;
+                }
+                return linecount;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return 0;
+            }
+        }
+        #endregion
+
+        #region 資材種類コンボボックスの値変更時
+        /// <summary>
+        /// 資材種類コンボボックスの値変更
+        /// </summary>
+        /// <returns></returns>
+        private void cmbTypes_SelectedIndexChanged(object sender, EventArgs e)
+        {
+            if (cmbTypes.SelectedValue != null && cmbTypes.SelectedValue.ToString() != txtTypeBefore.Text)
+            {
+                if (m_bChengeAns)
+                {
+                    if (MessageBox.Show("データに変更があります、登録せずに資材種類を変更してよろしいですか？。", "確認"
+                        , MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.No)
+                    {
+                        cmbTypes.SelectedValue = CommonMotions.cnvInt(txtTypeBefore.Text);
+                        return;
+                    }
+                }
+                ItemListDisplay();
+            }
+        }
+        #endregion
+
+        /// <summary>
+        /// 行データクリア
+        /// </summary>
+        /// <param name="iIndex">行カウント</param>
+        private void SetRowClearData(int iIndex)
+        {
+            // クリアデータセット
+            dgvMaster[(int)DispColumn.RowState, iIndex].Value = DataRowState.Unchanged;
+            dgvMaster[(int)DispColumn.DisplayOrder, iIndex].Value = "";
+            dgvMaster[(int)DispColumn.MaterialItemKey, iIndex].Value = "";
+            dgvMaster[(int)DispColumn.NameString, iIndex].Value = "";
+        }
+        /// <summary>
+        /// グリッド最終行での処理
+        /// </summary>
+        private void GridLastLine()
+        {
+            // 最終行判定
+            if (dgvMaster.CurrentCell.RowIndex == dgvMaster.Rows.Count - 1)
+            {
+                // 最終列判定
+                if (dgvMaster.CurrentCell.ColumnIndex == (int)DispColumn.NameString)
+                {
+                    // 1行追加
+                    dgvMaster.Rows.Add();
+                    // クリアデータセット
+                    SetRowClearData(dgvMaster.Rows.Count - 1);
+                    // №再採番
+                    LineReNumbering();
+                }
+
+            }
+        }
+        /// <summary>
+        /// グリッド採番処理
+        /// </summary>
+        private void LineReNumbering()
+        {
+            int icnt = 1;
+            foreach (DataGridViewRow r in dgvMaster.Rows)
+            {
+                // 表示されているものだけ採番
+                if (r.Visible)
+                    r.Cells[(int)DispColumn.DisplayOrder].Value = (icnt++).ToString();
+                else
+                    r.Cells[(int)DispColumn.DisplayOrder].Value = "999";
+            }
+        }
+        /// <summary>
+        /// 行数統一処理
+        /// </summary>
+        private void unifyLines(DataGridView dgv)
+        {
+            // 表示行が足りない場合は追加する
+            if (dgv.Rows.Count <= CommonDefine.s_MaxInitLineCountMastamente)
+            {
+                int iAddLine = CommonDefine.s_MaxInitLineCountMastamente - dgv.Rows.Count;
+                for (int i = 0; i < iAddLine; i++)
+                {
+                    dgv.Rows.Add();
+                }
+            }
+        }
+
+        /// <summary>
+        /// 行追加押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnLineEntry_Click(object sender, EventArgs e)
+        {
+            // 行がない場合は作成して抜ける
+            if (dgvMaster.Rows.Count == 0)
+            {
+                if (MessageBox.Show("行を追加します", "追加確認"
+                                    , MessageBoxButtons.OKCancel, MessageBoxIcon.Information) == DialogResult.Cancel) return;
+
+                // 行追加
+                dgvMaster.Rows.Add();
+                // クリアデータセット
+                SetRowClearData(0);
+                // №再採番
+                LineReNumbering();
+                //　変更フラグOn
+                valueChange(sender, e);
+                // フォーカス移動
+                dgvMaster.Focus();
+                return;
+            }
+
+            // メッセージ表示
+            BtnTextCustomMessageBox msg = new BtnTextCustomMessageBox();
+            msg.ButtonText.No = "前へ追加";
+            msg.ButtonText.Yes = "後へ追加";
+            msg.ButtonText.Cancel = "キャンセル";
+            DialogResult resRet = msg.Show("行の前・後を選択してください。", "追加確認"
+                                            , MessageBoxButtons.YesNoCancel, MessageBoxIcon.Information);
+
+            // キャンセルは処理しない
+            if (resRet == DialogResult.Cancel) return;
+
+            // カレント行取得
+            int iIndex = dgvMaster.CurrentRow.Index;
+            // 最終行
+            if (iIndex == dgvMaster.RowCount - 1)
+            {
+                if (resRet == DialogResult.No)
+                {
+                    // 前
+                    dgvMaster.Rows.Insert(iIndex);
+                }
+                else if (resRet == DialogResult.Yes)
+                {
+                    // 後
+                    dgvMaster.Rows.Add();
+                    iIndex = (dgvMaster.RowCount - 1);
+                }
+            }
+            else
+            {
+                if (resRet == DialogResult.Yes)
+                {
+                    // 後ろ
+                    ++iIndex;
+                }
+                dgvMaster.Rows.Insert(iIndex);
+            }
+
+            // クリアデータセット
+            SetRowClearData(iIndex);
+
+            // №再採番
+            LineReNumbering();
+
+            //　変更フラグOn
+            valueChange(sender, e);
+
+            // フォーカス移動
+            dgvMaster.Focus();
+
+        }
+
+        /// <summary>
+        /// 素材種類のロード
+        /// </summary>
+        private void LoadMaterialKind()
+        {
+            IOMaterialTypes IoMt = new IOMaterialTypes();
+            try
+            {
+                List<MaterialKindMaster> itemList = new List<MaterialKindMaster>();
+                if (!IoMt.SelectAction(" Where DeleteFlg = 0 Order By DisplayOrder ASC", ref itemList)) return;
+                if (itemList.Count == 0) return;
+
+                List<KeyValuePair<int, string>> DataList = new List<KeyValuePair<int, string>>();
+                //DataList.Add(new KeyValuePair<int, string>(0, ""));
+                // データ表示
+                for (int i = 0; i < itemList.Count; i++)
+                {
+                    KeyValuePair<int, string> keyval = new KeyValuePair<int, string>(itemList[i].MaterialKindCode, itemList[i].MaterialKindName);
+
+                    DataList.Add(keyval);
+                }
+
+                //初期選択があるため事前に指定
+                cmbTypes.ValueMember = "Key";
+                cmbTypes.DisplayMember = "Value";
+
+                // コンボボックス初期表示
+                ComboBoxAction.InitDataSetCombBox(cmbTypes, DataList, false);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                IoMt.close();
+                IoMt = null;
+            }
+        }
+
+        /// <summary>
+        /// 資材品目の表示
+        /// </summary>
+        private void ItemListDisplay()
+        {
+            List<MaterialItemMaster> mim = new List<MaterialItemMaster>();
+
+            if (cmbTypes.SelectedIndex < 0) return;
+
+            string strMaterialKindCode = cmbTypes.SelectedValue.ToString();
+
+            try
+            {
+                dgvMaster.Rows.Clear();
+
+                // 資材品目抽出条件
+                string strSQL = string.Format(" Where MaterialKindCode = {0} And DeleteFlg = 0 Order By DisplayOrder ASC", strMaterialKindCode);
+                if (!m_IoMt.SelectAction(strSQL, ref mim,false)) return;
+
+                // データ表示
+                int icnt = 0;
+                foreach (MaterialItemMaster work in mim)
+                {
+                    dgvMaster.Rows.Add((icnt + 1)
+                                        , work.MaterialItemCode.ToString()
+                                        , work.MaterialItemName);
+
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.RowState].Value = DataRowState.Unchanged;
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialItemKey].Value = work.MaterialItemCode;
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.NameString].Value = work.MaterialItemName;
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.NameString].ToolTipText = work.MaterialItemName;
+                    icnt++;
+                }
+
+                // №再採番
+                LineReNumbering();
+
+                m_bChengeAns = false;
+
+                txtTypeBefore.Text = cmbTypes.SelectedValue.ToString();
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// セル値変化
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellValueChanged(object sender, DataGridViewCellEventArgs e)
+        {
+            // インデックス外は処理しない
+            if (e.RowIndex < 0 || e.ColumnIndex < 0) return;
+            // null値は処理しない
+            if (dgvMaster.Rows[e.RowIndex].Cells[e.ColumnIndex].Value == null) return;
+
+            // 値が変わればツールチップを変更する
+            dgvMaster.Rows[e.RowIndex].Cells[e.ColumnIndex].ToolTipText
+                = CommonMotions.cnvString(((DataGridView)sender).Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
+            // 変更フラグON
+            m_bChengeAns = true;
+            // セル更新
+            dgvMaster.Rows[dgvMaster.CurrentCell.RowIndex].Cells[(int)DispColumn.RowState].Value = DataRowState.Modified;
+            Console.Write("場所 {0} ", "dgvMaster_CellValueChanged");
+            Console.WriteLine("     {0} 行目 更新", dgvMaster.CurrentCell.RowIndex);
+
+        }
+
+        private void dgvMaster_CellClick(object sender, DataGridViewCellEventArgs e)
+        {
+            setButtonEnable();
+        }
+
+        private void dgvMaster_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
+        {
+            // ダイアログとして使用するとき以外は処理しない
+
+        }
+
+        private void dgvMaster_CellEnter(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                DataGridView dgv = (DataGridView)sender;
+
+                if (dgv.CurrentCell.ReadOnly) return;
+
+                //列によってIMEのモードを変更する
+                if (dgv.Columns[e.ColumnIndex].Name.Equals("Column3"))
+                {
+                    dgv.ImeMode = ImeMode.On;
+                }
+                else
+                {
+                    dgv.ImeMode = ImeMode.Disable;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+        /// <summary>
+        /// ボタン制御
+        /// </summary>
+        private void setButtonEnable()
+        {       
+            try
+            {
+                // 一覧が1行選択されている場合、ボタンを活性にする
+                if (dgvMaster.SelectedCells.Count == 1)
+                {
+                    btnLineEntry.Enabled = true;
+                    btnDataDelete.Enabled = true;
+                    btnDispUp.Enabled = true;
+                    btnDispDown.Enabled = true;
+                }
+                // 一覧が選択されていない場合、ボタンを非活性にする
+                else
+                {
+                    btnLineEntry.Enabled = false;
+                    btnDataDelete.Enabled = false;
+                    btnDispUp.Enabled = false;
+                    btnDispDown.Enabled = false;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// PreviewKeyDownイベント
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
+        {
+            //複数選択時は削除させない
+            if(e.KeyCode == Keys.Delete && dgvMaster.SelectedCells.Count!=1)
+            {
+                dgvMaster.ClearSelection();
+            }
+        }
+    }
+}
\ No newline at end of file
